#!/usr/bin/env bash

# Read in language file
source ${BBROOTDIR}/lang/${BBLANG}/audio_menu.lang

# Read in common functions
source ${BBROOTDIR}/misc/commonfunctions.sh

#This function lets you swap cds if you only have one device.
#(CDwriter and CDreader is same device.)
insert_new_CD()
{
        while true; do
                echo $bb_am_enter_2
                read temp
                if [[ "$temp" = "" ]]; then
                        break
                else
                        continue
                fi
        done
}

# A little function that looks for mp3s

check_for_mp3s()
{
	cd ${BBBURNDIR}
	while read MPTHREE; do
        	existing="yes"
	done < <(find ${BBBURNDIR} -iname "*.[Mm][Pp]3" | sort)

	if [[ "$existing" != "yes" ]]; then
        	echo
        	echo "$bb_am_nomp3s${BBBURNDIR}"
	else
		${BBROOTDIR}/convert/convert_mp3s.sh
	fi
}

# A function that checks for ogg files

check_for_oggs()
{
	cd ${BBBURNDIR}
	while read OGGS; do
		existing="yup"
	done < <(find ${BBBURNDIR} -iname "*.[Oo][Gg][Gg]" | sort)

	if [[ "$existing" != "yup" ]]; then
        	echo
        	echo "$bb_am_nooggs${BBBURNDIR}"
	else
		${BBROOTDIR}/convert/convert_oggs.sh	
	fi
}

# A function that checks for flac files

check_for_flacs()
{
	cd ${BBBURNDIR}
	while read FLACS; do
		existing="aight"
	done < <(find ${BBBURNDIR} -iname "*.[Ff][Ll][Aa][Cc]" | sort)

	if [[ "$existing" != "aight" ]]; then
		echo
		echo "$bb_am_noflacs${BBBURNDIR}"
	else
		${BBROOTDIR}/convert/convert_flacs.sh
	fi
}

# A function that adjust the volume of wav
# audio files to a standard volume level.

normalization()
{
        if [[ "$BBNORMALIZE" = "yes" ]]; then
                cd ${BBBURNDIR}
                for i in *.wav; do
		   echo;echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_norm_1$i...${BBCOLOROFF}";
                   ${BB_NORMCMD} -v -m $i;
                done
        fi
}

# Function that valide the input of "y" or "n".

conf_yes_no()
{
	unset ANSWER
	while [ "${ANSWER}" != 'y' ] && [ "${ANSWER}" != 'n' ]
	do 
		echo -n $bb_am_conf_2
		read ANSWER
	done

}

# Function that control errors.

conf_error()
{
	STDERROR=$?
	# If there is any error return to main menu.
	if [[ ${STDERROR} -ne 0 ]]; then
		echo -e "${BBTABLECOLOR}$bb_am_err_1${BBCOLOROFF}"
		sleep 3
		exit
	fi
}	


# Simple function that valide confirmation of song names.

confirmation()
{
	echo
	if [[ ! -f "${BBBURNDIR}/song_name.txt" ]]; then
		exit
	else
		echo -e "${BBTABLECOLOR}|>${BBMAINCOLOR}$bb_am_conf_1${BBCOLOROFF}"
		cat -n ${BBBURNDIR}/song_name.txt
		echo -e "${BBSUBCOLOR}"
		conf_yes_no		# Valid input.
		echo -e "${BBCOLOROFF}"
		
		if [[ ${ANSWER} = 'n' ]];
		then
			rm -f ${BBBURNDIR}/song_name.txt
			rm -f ${BBBURNDIR}/tracks.txt
			exit
		fi
	fi
}

# Function for interactive naming of files.
named()
{
	# Delete old lists of songs rip.
	rm -f ${BBBURNDIR}/*.txt

	# cdda2wav show information of tracks to rip.
	# it's great for see which track would to be 
	# rip and the time of duration of the tracks.
	echo -e "${BBSUBCOLOR}$bb_am_named_1${BBCOLOROFF}"
	sleep 1s
	${BB_CDAUDIORIP} -D ${BBCDROM} -H -J -v toc

	# If there is any error return to main menu.
	conf_error
	
	TRACK=0
	while [ "${TRACK}" != "" ]; do
		echo;echo -en "${BBMAINCOLOR}$bb_am_named_2"
		echo;echo -en "${BBMAINCOLOR}$bb_am_named_3${BBTABLECOLOR}|>${BBCOLOROFF} "
		read TRACK
	
			if [ "${TRACK}" != "" ];
			then
				# Only permit integer numbers standing the format in the numbers of back prompt.
				number_track=`printf '%02d' ${TRACK}`			
	
				# This line puts track numbers of the input standard into tracks.txt.	
				echo "${number_track}" >> ${BBBURNDIR}/tracks.txt
			else
			# If nothing is entered at the prompt then exit loop.
				continue
			fi

		echo
		echo -e "${BBMAINCOLOR}$bb_am_named_4"
		echo -e "${BBMAINCOLOR}$bb_am_named_5"
		echo -en "${BBMAINCOLOR}$bb_am_named_6${number_track} ${BBTABLECOLOR}|>${BBCOLOROFF} "
		read song_name

		# If the song_name variable = space blank then, change  
		# fill that with the number of the track to ripped.
		if [[ "${song_name}" = "" ]]; then 
			song_name=`echo "${number_track}.-Track"` 
		else
		
		# If the song_name variable contained some signs and caracters specials, 
		# that difficulty the naming in bash shell, to be equal to nothing.
		# Read sed man page to see how it work.
		song_name=`echo "$song_name" | sed -e 's/(//g'		\
					-e 's/)//g' -e 's/*//g' 	\
					-e 's/?//g' -e 's///g' 	\
					-e 's/\///g' -e 's/&//g'`
		fi
		# This line puts song name of the input standard into song_name.txt.	
	     	echo ${song_name} >> ${BBBURNDIR}/song_name.txt
done
}     
	
# Function rip the tracks or songs selects.

rip()
{
	confirmation
	cd ${BBBURNDIR}
	track=0	
	while [ "${track}" != "" ]; do
	
		# Read the track to rip of the files in temp directory.
		track=`sed -ne '1p' ${BBBURNDIR}/tracks.txt`
		if [[ "${track}" = "" ]]; then
			continue
		else
                   	echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_rip_1${track}...${BBCOLOROFF}"
		
			# Begin Rip.	
			 ${BB_CDAUDIORIP} -D ${BBCDROM} -x -t ${track} -O wav ${track} #Changed from cdparanoia to cdda2wav
			sleep 2s
			
			# This two lines add '.wav' to finished of the tracks/song_name variable for rename.
			track=`sed -ne '1p' ${BBBURNDIR}/tracks.txt | sed -e 's/$/.wav/g'`
			song_name=`sed -ne '1p' ${BBBURNDIR}/song_name.txt | sed -e 's/$/.wav/g'`
	
			# Rename the tracks that has been ripped, by the name 
			# get back by users in prompt.
			mv "${track}" "${song_name}"
			
			# Remove the song that has been ripped. 
			sed -e '1d' ${BBBURNDIR}/song_name.txt >> ${BBBURNDIR}/temp_song.txt
			mv ${BBBURNDIR}/temp_song.txt ${BBBURNDIR}/song_name.txt
			sed -e '1d' ${BBBURNDIR}/tracks.txt >> ${BBBURNDIR}/temp_tracks.txt
			mv ${BBBURNDIR}/temp_tracks.txt ${BBBURNDIR}/tracks.txt
		fi
	 done
        # Remove temp files.
	rm -f ${BBBURNDIR}/tracks.txt
	rm -f ${BBBURNDIR}/song_name.txt
	rm -f ${BBBURNDIR}/*.inf
	
	eject ${BBCDROM}
	echo -e "${BBSUBCOLOR}$bb_am_rip_2${BBCOLOROFF}"
	sleep 2s
}     

# Function Encode Filter Command.

encode_filter()
{
	if [[ "$ENCODEFILTER" != "" ]]; then
                echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_encfilt(${ENCODEFILTER})${BBCOLOROFF}"
		`${ENCODEFILTER} ${BBBURNDIR}/*.${format}`
	fi			
}

copy_audio_cd()
{
	# Copy an audio cd.
    cd ${BBBURNDIR}
    if ${BB_CDAUDIORIP} -D ${BBCDROM} -v all -B -Owav; then      #Changed from cdparanoia to cdda2wav
	eject ${BBCDROM}
	echo $bb_am_rip_2
	# Normalize WAV's.
	normalization 
	
	if [[ ${BBNUMDEV} == 1 ]]; then                     #Check number of devices
	    insert_new_CD
	fi
	
	if eval "${BB_CDBURNCMD} -v dev=${BBCDWRITER} speed=${BBSPEED} \
	    ${BBOPT_ONE}:+\"driveropts=${BBOPT_ONE}\" ${BBDTAO} \
	    -useinfo ${BBBURNDIR}/*.[Ww][Aa][Vv]"; then
	    echo $bb_am_ch3_1
	    wait_for_enter
	else
	    echo $bb_am_ch3_2
	    wait_for_enter
	fi
    else
	echo "$bb_am_ch3_3${BBCDROM}"
	wait_for_enter
    fi
}

copy_cd_to_hd()
{
    # Copy an audio cd to HD
    cd ${BBBURNDIR}
    ${BB_CDAUDIORIP} -D ${BBCDROM} -v all -B -Owav
    eject ${BBCDROM}
    
    # Normalize WAV's.
    normalization
    
    echo "$bb_am_ch4_1${BBBURNDIR}.$bb_am_ch4_2"
    echo $bb_am_ch4_3
    wait_for_enter                
}

create_mp3s_from_wavs()
{
#Create Mp3s from Wavs in BURNDIR
    cd ${BBBURNDIR}
    
    while read WAV; do
	echo
	if ${BB_MP3ENC} --preset cd "${WAV}" "${WAV%%.wav}.mp3"; then
	    echo "${WAV%%.wav}.mp3$bb_am_ch6_1"
	else
	    echo "${WAV}:$bb_am_ch6_2"
	fi
	echo
	existing="yes"
    done < <(find "${BBBURNDIR}" -iname "*.[Ww][Aa][Vv]" | sort)
    
    if [[ "$existing" != "yes" ]]; then
	echo
	echo "$bb_am_ch6_3${BBBURNDIR}"	
    else
	# Encode Filter Command. 
	format=mp3
	encode_filter
    fi
    sleep 2s
    continue
}

create_oggs_from_wavs()
{
#Create Oggs from Wavs in BURNDIR
    cd ${BBBURNDIR}
    
    while read WAV; do
	echo
	if ${BB_OGGENC} -b ${BBBITRATE} "${WAV}"; then
	    echo $bb_am_ch7_1
	else
	    echo "${WAV}:$bb_am_ch6_2"
	fi
	echo
	existing="yes"
    done < <(find "${BBBURNDIR}" -iname "*.[Ww][Aa][Vv]" | sort)
    
    if [ "$existing" != "yes" ]; then
	echo
	echo "$bb_am_ch6_3${BBBURNDIR}"
    else
	# Encode Filter Command. 
	format=ogg
	encode_filter
    fi
    sleep 2s
    continue
}

create_flacs_from_wavs()
{
# Create flacs from Wavs in BURNDIR
    cd ${BBBURNDIR}
    
    while read WAV; do
	echo
	if ${BB_FLACCMD} "${WAV}"; then
	    echo $bb_am_ch7_1
	else
	    echo "${WAV}:$bb_am_ch6_2"
	fi
	echo
	existing="yes"
    done < <(find "${BBBURNDIR}" -iname "*.[Ww][Aa][Vv]" | sort)
    
    if [[ "$existing" != "yes" ]]; then
	echo
	echo "$bb_am_ch6_3${BBBURNDIR}"
    else
	#Encode Filter command
	format=flac
	encode_filter
    fi
    sleep 2s
    continue
}

create_mp3s_from_cd()
{
# Create Mp3s from an audio cd.
#First, name and rip the tracks
 
# Give name to the tracks.
    named
    # Rip the tracks in wav audio file.
    rip
    # Normalize WAV's.
    normalization
    #Now create the Mp3s
			
    while read WAV; do
	echo;echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_ch9_1${BBCOLOROFF}"
	
	if ${BB_MP3ENC} --preset cd ${WAV} ${WAV%%.wav}.mp3; then
	    echo "${WAV%%.wav}.mp3$bb_am_ch6_1"
	else
	    echo "${WAV}:$bb_am_ch6_2"
	fi
	echo
	existing="yes"
    done < <(find "$BURNDIR" -iname "*.[Ww][Aa][Vv]" | sort)
    
    if [[ "$existing" != "yes" ]]; then
	echo
	echo "$bb_am_ch6_3${BBBURNDIR}"
	sleep 2s
	continue
    else
	# Encode Filter Command. 
	format=mp3
	encode_filter
    fi
    
    echo "$bb_am_ch9_2${BBBURNDIR}"
    rm ${BBBURNDIR}/*.[Ww][Aa][Vv]
    wait_for_enter
}

create_oggs_from_cd()
{
# Create Oggs from an audio cd.
#First, name and rip the tracks

# Give name to the tracks.
    named
# Rip the tracks in wav audio file.
    rip
# Normalize WAV's.
    normalization
    
#Now create the Oggs.
    
    while read WAV; do
	echo;echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_ch10_1${BBCOLOROFF}"
	if ${BB_OGGENC} -b ${BBBITRATE} "${WAV}"; then
	    echo $bb_am_ch7_1
	else
	    echo "${WAV}:$bb_am_ch6_2"
	fi
	echo
	existing="yes"
    done < <(find "${BBBURNDIR}" -iname "*.[Ww][Aa][Vv]" | sort)
    
    if [[ "$existing" != "yes" ]]; then
	echo
	echo "$bb_am_ch6_3${BBBURNDIR}"
	sleep 2s
	continue
    else
	# Encode Filter Command. 
	format=ogg
	encode_filter	
    fi
    
    echo "$bb_am_ch10_2${BBBURNDIR}"
    rm ${BBBURNDIR}/*.[Ww][Aa][Vv]
    wait_for_enter
}

create_flacs_from_cd()
{
# Create flacs from cd
# Give name to the tracks.
    named
# Rip the tracks in wav audio file.
    rip
# Normalize WAV's.
    normalization
                        
# Now create Flacs
			
    while read WAV; do
	echo
	if ${BB_FLACCMD} "${WAV}"; then
	    echo $bb_am_ch7_1
	else
	    echo "${WAV}:$bb_am_ch6_2"
	fi
	echo
	existing="yes"
    done < <(find "${BBBURNDIR}" -iname "*.[Ww][Aa][Vv]" | sort)
    
    if [[ "$existing" != "yes" ]]; then
	echo
	echo "$bb_am_ch6_3${BBBURNDIR}"
	sleep 2s
	continue
    else
	# Function Filter Command. 
	format=flac
	encode_filter	
    fi
    
    echo "$bb_am_ch11_1${BBBURNDIR}"
    rm ${BBBURNDIR}/*.[Ww][Aa][Vv]
    wait_for_enter			
}

####PROGRAM START#####

while true; do
        # This is for the numbering of the menu choices. It is
        # updated once before each entry printout in the menu
        # except exit which should always be 0. The variable must
	# be reset within this while loop or bad things will happen.
        (( bb_m_c = 0 ))
        # <colors>
	#source "$BBROOTDIR"/misc/colors.idx
        # </colors>   
	clear
        # <table>
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|${BBHEADCOLOR} ${BBVERSION} ${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}|-(${BBSUBCOLOR}$bb_am_menu_title${BBTABLECOLOR})"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_1"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_2"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_3"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_4"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_5"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_6"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_7"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_8"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_9"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_10"
		(( bb_m_c += 1 ))
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_am_menu_11"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 0) $bb_am_menu_0"
        echo -e "${BBTABLECOLOR}|"
	echo -n -e "${BBINPUTCOLOR}$bb_am_menu_input[0-$bb_m_c] |>${BBMAINCOLOR} "        
        read action
        echo -e "${BBCOLOROFF}"
        # </table>

 case $action in
     1)  # Burn Audio from Mp3s
	 check_for_mp3s                  
	 check_for_oggs			
	 check_for_flacs			
	 ${BBROOTDIR}/burning/burning.sh --audio
	 ;;
     2) # Burn Audio Directly
	 ${BBROOTDIR}/burning/burning.sh --pipeline
	 ;;
     3)	
	 copy_audio_cd
	 ;;
     4)      
	 copy_cd_to_hd
	 ;;
     5)	# Burn a xmms playlist
	 if eval ${BBROOTDIR}/misc/xmmsread.sh; then
	     ${BBROOTDIR}/burning/burning.sh --audio
	 else
	     echo $bb_am_ch5
	     wait_for_enter
	 fi
	 ;;
     6)
	 create_mp3s_from_wavs
	 ;;
     7)
	 create_oggs_from_wavs
	 ;;
     8)
	 create_flacs_from_wavs
	 ;;
     9)
	 create_mp3s_from_cd
	 ;;
     10)
	 create_oggs_from_cd
	 ;;
     11)
	 create_flacs_from_cd
	 ;;
     0)      # Abort
	 break
	 ;;
     *)
	 echo "$bb_am_error[0-$bb_m_c]"
	 wait_for_enter
	 continue                                #Else go to menu
	 ;;
 esac
done
