#!/usr/bin/env bash

# Read in language
source ${BBROOTDIR}/lang/${BBLANG}/mount.lang

# Read in common functions
source ${BBROOTDIR}/misc/commonfunctions.sh

mount_device()
{
    grep cdrom /etc/fstab | sort && grep dvd /etc/fstab | sort
    echo; echo $bb_mnt_ch1_1
    echo $bb_mnt_ch1_2
    echo $bb_mnt_ch1_3
    echo $bb_mnt_ch1_4
    echo -n "|> "
    read BBDEVICE
    if [[ "${BBDEVICE}" == "" ]]; then
	echo $bb_mnt_ch1_5
	wait_for_enter
	continue
    else
	echo "$bb_mnt_ch1_6${BBDEVICE}..."
	if mount ${BBDEVICE} &> /dev/null; then
	    echo "${BBDEVICE}$bb_mnt_ch1_7"
	    sleep 2s
	    continue
	else
	    echo $bb_mnt_ch1_8
	    echo $bb_mnt_ch1_9
	    echo $bb_mnt_ch1_10
	    wait_for_enter
	    continue
	fi
    fi
}

umount_device()
{
    if [ "$(grep -c '\(cdrom\|dvd\|cdrw\|cdwriter\)' /etc/mtab)" == 0 ]; then
	echo $bb_mnt_ch2_1
	wait_for_enter
    else
	grep cdrom /etc/mtab | sort && grep dvd /etc/mtab | sort
	echo; echo $bb_mnt_ch2_2
	echo -n "|> "
	read BBDEVICE
	if umount ${BBDEVICE} &> /dev/null; then
	    echo "${BBDEVICE}$bb_mnt_ch2_3"
	    wait_for_enter
	    continue
	else
	    echo $bb_mnt_ch2_4
	    echo $bb_mnt_ch2_5
	    wait_for_enter
	    continue
	fi
    fi
}

eject_device()
{
    grep cdrom /etc/fstab | sort && grep dvd /etc/fstab | sort
    echo $bb_mnt_ch3_1
    echo $bb_mnt_ch3_1b
    echo -n "|> "
    read BBDEVICE
    if [[ $BBDEVICE == "" ]]; then
	echo $bb_mnt_ch3_1c
	wait_for_enter
	continue
    else
	if ${BB_EJECT} ${BBDEVICE} &> /dev/null; then
	    echo "${BBDEVICE}$bb_mnt_ch3_2"
	    wait_for_enter
	    continue
	else
	    echo $bb_mnt_ch3_3
	    echo $bb_mnt_ch3_4
	    wait_for_enter
	    continue
	fi
    fi
}

#####PROGRAM START#####
while true; do
        # This is for the numbering of the menu choices. It is
        # updated once before each entry printout in the menu
        # except exit which should always be 0. The variable must
	# be reset within this while loop or bad things will happen.
        (( bb_m_c = 0 ))
        # <colors>
	#source "$BBROOTDIR"/misc/colors.idx
        # </colors>
    clear
        # <table>
    echo -e "${BBTABLECOLOR}${BBDECOLINE}"
    echo -e "${BBTABLECOLOR}|${BBHEADCOLOR} ${BBVERSION} ${BBTABLECOLOR}|"
    echo -e "${BBTABLECOLOR}${BBDECOLINE}"
    echo -e "${BBTABLECOLOR}|"
    echo -e "${BBTABLECOLOR}|-(${BBSUBCOLOR}$bb_mnt_menu_title${BBTABLECOLOR})"
	(( bb_m_c += 1 ))
    echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_mnt_menu_1"
	(( bb_m_c += 1 ))
    echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_mnt_menu_2"
	(( bb_m_c += 1 ))
    echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} $bb_m_c) $bb_mnt_menu_3"
    echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 0) $bb_mnt_menu_0"
    echo -e "${BBTABLECOLOR}|"
    echo -n -e "${BBINPUTCOLOR}$bb_mnt_menu_input[0-$bb_m_c] |>${BBMAINCOLOR} "
    read action
    echo -e "${BBCOLOROFF}"
        # </table>
    
    case $action in
	1)      # Mount device
	    mount_device
	    ;;
	2)	# Unmount device
	    umount_device
	    ;;
	3)	# Eject device
	    eject_device
	    ;;
	0)	# Back to main
	    break
	    ;;
	*)
	    echo "$bb_mnt_error[0-$bb_m_c]"
	    wait_for_enter
	    continue
	    ;;
    esac
done
